function [recon2,ws,recon,source,target ]=GRAPPA_MB2aa_asym_kernel_new_blocking(reduced_data,ACS,kernel,kernel_height,kernel_width,use_reduced_data,~,MBACS_dim,no_MB_matrix_inversion)
%[recon,kernel,KSP_red]=grappa_MB(reduced_data,ACS,reduction,kernel,kernel_width,kernel_height)
if ~exist('kernel_height'); kernel_height=5;end
if ~exist('kernel_width'); kernel_width=5;end
if ~exist('use_reduced_data'); use_reduced_data=0;end
if ~exist('use_reduced_data'); if isempty('use_reduced_data'); use_reduced_data=0; end; end
if ~exist('ROI_size'); ROI_size=1; end
if ~exist('no_MB_matrix_inversion'); no_MB_matrix_inversion=0; end
if exist('MBACS_dim')
    if ~isempty(MBACS_dim)
         if use_reduced_data==0
  reduced_data     =reduced_data([max(MBACS_dim(1),1):min(MBACS_dim(2),end)],[max(1,MBACS_dim(3)):min(MBACS_dim(4),end)],:);
         end
    ACS            =ACS([max(MBACS_dim(1),1):min(MBACS_dim(2),end)],[max(1,MBACS_dim(3)):min(MBACS_dim(4),end)],:,:);   
    end
end

%%%  ROI_size ==1  means just center point
%%%  ROI_size ==0  means all except for edges
%%%  ROI_size ==[]  means all


%%%%%%%   reduced data     (#pe, RO, number of coils)
%%%%%%%   ACS              (#pe, RO, number of coils, slices)
%%%%%%%   kernel           ( interpolation kernel)
%%%%%%%   kernel_width     ( integer even or odd)
%%%%%%%   kernel_height    ( even integer only)

[ny,nx,nc2,nvalues]=size(reduced_data);
[nyacs,nxacs,nc,nzacs]=size(ACS);     %Get the size of both the input data and the ref data

if isempty(kernel)
    clear block_extraction_red block_extraction_ACS
    for idx_nvalues=1:nvalues
       for idx_ch=1:nc2
         block_extraction_red(:,:,idx_ch,idx_nvalues)=im2col(reduced_data(:,:,idx_ch,idx_nvalues),[kernel_height kernel_width],'sliding');
       end
    end
    
    for idx_ch=1:nc
      for nsl=1:nzacs
         block_extraction_ACS(:,:,idx_ch,nsl)=im2col(ACS(:,:,idx_ch,nsl),[kernel_height kernel_width],'sliding');
      end
    end
      
      block_extraction_ACS=permute(block_extraction_ACS,[2 4 1 3 ]);
      block_extraction_red=permute(block_extraction_red,[2 4 1 3]);
         
        tmp=block_extraction_ACS(:,:,:,:); s_tmp=size(tmp);
      target=reshape(tmp,[s_tmp(1)*s_tmp(2) s_tmp(3)*s_tmp(4) ]);
      
        tmp=block_extraction_ACS(:,:,:,:); s_tmp=size(tmp);
      target2=reshape(tmp,[s_tmp(1) s_tmp(2) s_tmp(3)*s_tmp(4) ]);
          
       tmp=block_extraction_ACS(:,:,ceil(end/2),:); s_tmp=size(tmp);
      source=reshape(tmp,[s_tmp(1) s_tmp(2) s_tmp(3)*s_tmp(4) ]);      
  
         CMK=(target'*  target)\target';
       CMK=reshape(CMK,[size(CMK,1) size(CMK,2)/size(source,2) size(source,2)]) ;
        for sl=1:size(source,2)
       ws(:,:,1,sl)=CMK(:,:,sl)* permute(source(:,sl,:),[1 3 2]);
        end   
 else
    ws=kernel;
end

[ny,nx,nc2,nvalues]=size(reduced_data);
[nyacs,nxacs,nc,nzacs]=size(ACS);     %Get the size of both the input data and the ref data
sizeacs=size(ACS);

clear block_extraction_red
     for idx_nvalues=1:nvalues
     for idx_ch=1:nc2
          block_extraction_red(:,:,idx_ch,idx_nvalues)=im2col(reduced_data(:,:,idx_ch,idx_nvalues),[kernel_height kernel_width],'sliding');
     end
     end
      src_red   = reshape(permute(block_extraction_red,[2 1 3 4]),size(block_extraction_red,2),[]);

resolved=multiprod(src_red,ws,[1 2]);

%%%%  resort data with col2im
if size(resolved,3)==kernel_height*kernel_width  

 for idx_nc=nc:-1:1
    for idx_nsl=nzacs:-1:1
            recon_pts_tmp=permute(resolved(:,idx_nc,:,idx_nsl),[3 1 2 4]);
        for idx_npt=size(ws,3):-1:1
            recon_pts=recon_pts_tmp;
            recon_pts(setdiff(1:size(ws,3),idx_npt),:)=0; %%%  Set all values except for one value to zero
                recon(:,:,idx_nc,idx_nsl,idx_npt)=...
                     complex( col2imstep(double(real(recon_pts)), [ny nx],[kernel_height kernel_width]),...
                      col2imstep(double(imag(recon_pts)), [ny nx],[kernel_height kernel_width]));   
        end
    end
  end
  
recon2=sum(recon(:,:,:,:,1:end-1),5)./( sum(recon(:,:,:,:,1:end-1)~=0,5));
recon2(isnan(recon2))=0;

elseif size(resolved,3)==1
    
    recon_pts=permute(resolved,[3 1 2 4]);
   recon(:,:,:,:)=reshape(recon_pts,[ny-kernel_height+1],[nx-kernel_width+1],size(resolved,2),size(resolved,4)) ;
   recon2=zeros(size(recon,1)+kernel_height-1,size(recon,2)+kernel_width-1,size(recon,3),size(recon,4));
   recon2((kernel_height+1)/2:size(recon,1)+(kernel_height+1)/2-1  ,(kernel_width+1)/2:size(recon,2)+(kernel_width+1)/2-1  ,:,:  )=recon;
   
else  %  some points are truncated allready
    
    resolved=reshape(resolved,size(resolved,1),size(resolved,2),kernel_height-2,kernel_width-2,size(resolved,4));
       recon=reshape(resolved,[ny-kernel_height+1],[nx-kernel_width+1],size(resolved,2),size(resolved,3),size(resolved,4),size(resolved,5));
       recon=permute(recon,[1 2 3 6 4 5]);
recon2=zeros(size(recon,1)+size(recon,5)+1,size(recon,2)+size(recon,6)+1,size(recon,3),size(recon,4) );
recon2cnt=zeros(size(recon,1)+size(recon,5)+1,size(recon,2)+size(recon,6)+1 );

       for nidx1=1:size(recon,5)
         for nidx2=1:size(recon,6)
           recon2(nidx1+1:nidx1+size(recon,1)-1+1,nidx2+1:nidx2+size(recon,2)-1+1,:,:)= recon2(nidx1+1:nidx1+size(recon,1)-1+1,nidx2+1:nidx2+size(recon,2)-1+1,:,:)+...
              (recon(:,:,:,:,nidx1,nidx2));
           recon2cnt(nidx1+1:nidx1+size(recon,1)-1+1,nidx2+1:nidx2+size(recon,2)-1+1)= recon2cnt(nidx1+1:nidx1+size(recon,1)-1+1,nidx2+1:nidx2+size(recon,2)-1+1)+...
              (abs(recon(:,:,1,1,nidx1,nidx2))~=1);
         end
       end
       
       weight=1./(recon2cnt+eps).*(recon2cnt~=0); 
    recon2=repmat(weight,[1 1 size(recon2,3) size(recon2,4)]).*recon2;
    
end
